diff --git a/src/backend/executor/execTuples.c b/src/backend/executor/execTuples.c
index c46d65cf938..32bee3acd7e 100644
--- a/src/backend/executor/execTuples.c
+++ b/src/backend/executor/execTuples.c
@@ -101,6 +101,560 @@ static TupleDesc ExecTypeFromTLInternal(List *targetList,
  * ----------------------------------------------------------------
  */
 
+static void
+tts_virtual_init(TupleTableSlot *slot)
+{
+}
+
+static void
+tts_virtual_release(TupleTableSlot *slot)
+{
+}
+
+static void
+tts_virtual_clear(TupleTableSlot *slot)
+{
+	slot->nvalid = 0;
+	slot->flags |= TTS_ISEMPTY;
+}
+
+static void
+tts_virtual_getsomeattrs(TupleTableSlot *slot, int natts)
+{
+	elog(ERROR, "should not be called");
+}
+
+static void
+tts_virtual_materialize(TupleTableSlot *slot)
+{
+	elog(ERROR, "materializing a virtual tuple");
+}
+
+static HeapTuple
+tts_virtual_get_heap_tuple(TupleTableSlot *slot)
+{
+	Assert(!(slot->flags & TTS_ISEMPTY));
+
+	return heap_form_tuple(slot->tupleDescriptor,
+						   slot->values,
+						   slot->nulls);
+
+}
+
+static MinimalTuple
+tts_virtual_get_minimal_tuple(TupleTableSlot *slot)
+{
+	Assert(!(slot->flags & TTS_ISEMPTY));
+
+	return heap_form_minimal_tuple(slot->tupleDescriptor,
+								   slot->values,
+								   slot->nulls);
+}
+
+static HeapTuple
+tts_virtual_copy_heap_tuple(TupleTableSlot *slot)
+{
+	Assert(!(slot->flags & TTS_ISEMPTY));
+
+	return heap_form_tuple(slot->tupleDescriptor,
+						   slot->values,
+						   slot->nulls);
+
+}
+
+static MinimalTuple
+tts_virtual_copy_minimal_tuple(TupleTableSlot *slot)
+{
+	Assert(!(slot->flags & TTS_ISEMPTY));
+
+	return heap_form_minimal_tuple(slot->tupleDescriptor,
+								   slot->values,
+								   slot->nulls);
+}
+
+
+static void
+tts_heap_init(TupleTableSlot *slot)
+{
+}
+
+static void
+tts_heap_release(TupleTableSlot *slot)
+{
+}
+
+static void
+tts_heap_clear(TupleTableSlot *slot)
+{
+	HeapTupleTableSlot *hslot = (HeapTupleTableSlot *) slot;
+
+	if (slot->flags & TTS_SHOULDFREE)
+	{
+		heap_freetuple(hslot->tuple);
+		slot->flags &= ~TTS_SHOULDFREE;
+	}
+
+	slot->nvalid = 0;
+	slot->flags |= TTS_ISEMPTY;
+	hslot->off = 0;
+	hslot->tuple = NULL;
+}
+
+static void
+tts_heap_getsomeattrs(TupleTableSlot *slot, int natts)
+{
+	HeapTupleTableSlot *hslot = (HeapTupleTableSlot *) slot;
+
+	Assert(!(slot->flags & TTS_ISEMPTY));
+
+	slot_deform_tuple(slot, hslot->tuple, &hslot->off, natts);
+}
+
+static void
+tts_heap_materialize(TupleTableSlot *slot)
+{
+	HeapTupleTableSlot *hslot = (HeapTupleTableSlot *) slot;
+	MemoryContext oldContext;
+
+	Assert(!(slot->flags & TTS_ISEMPTY));
+
+	if (slot->flags & TTS_SHOULDFREE)
+		return;
+
+	slot->flags |= TTS_SHOULDFREE;
+	oldContext = MemoryContextSwitchTo(slot->mcxt);
+
+	if (!hslot->tuple)
+		hslot->tuple = heap_form_tuple(slot->tupleDescriptor,
+									   slot->values,
+									   slot->nulls);
+	else
+		hslot->tuple = heap_copytuple(hslot->tuple);
+
+	slot->nvalid = 0;
+	hslot->off = 0;
+
+	MemoryContextSwitchTo(oldContext);
+}
+
+static HeapTuple
+tts_heap_get_heap_tuple(TupleTableSlot *slot)
+{
+	HeapTupleTableSlot *hslot = (HeapTupleTableSlot *) slot;
+
+	Assert(!(slot->flags & TTS_ISEMPTY));
+	if (!hslot->tuple)
+		tts_heap_materialize(slot);
+
+	return hslot->tuple;
+}
+
+static MinimalTuple
+tts_heap_get_minimal_tuple(TupleTableSlot *slot)
+{
+	HeapTupleTableSlot *hslot = (HeapTupleTableSlot *) slot;
+
+	Assert(!(slot->flags & TTS_ISEMPTY));
+	if (!hslot->tuple)
+		tts_heap_materialize(slot);
+
+	return minimal_tuple_from_heap_tuple(hslot->tuple);
+}
+
+static HeapTuple
+tts_heap_copy_heap_tuple(TupleTableSlot *slot)
+{
+	HeapTupleTableSlot *hslot = (HeapTupleTableSlot *) slot;
+
+	Assert(!(slot->flags & TTS_ISEMPTY));
+	if (!hslot->tuple)
+		tts_heap_materialize(slot);
+
+	return heap_copytuple(hslot->tuple);
+}
+
+static MinimalTuple
+tts_heap_copy_minimal_tuple(TupleTableSlot *slot)
+{
+	HeapTupleTableSlot *hslot = (HeapTupleTableSlot *) slot;
+
+	if (!hslot->tuple)
+		tts_heap_materialize(slot);
+
+	return minimal_tuple_from_heap_tuple(hslot->tuple);
+}
+
+static void
+tts_heap_store_tuple(TupleTableSlot *slot, HeapTuple tuple, bool shouldFree)
+{
+	HeapTupleTableSlot *hslot = (HeapTupleTableSlot *) slot;
+
+	tts_heap_clear(slot);
+
+	slot->nvalid = 0;
+	hslot->tuple = tuple;
+	hslot->off = 0;
+	slot->flags &= ~TTS_ISEMPTY;
+
+	if (shouldFree)
+		slot->flags |= TTS_SHOULDFREE;
+}
+
+
+static void
+tts_minimal_init(TupleTableSlot *slot)
+{
+	MinimalTupleTableSlot *mslot = (MinimalTupleTableSlot *) slot;
+
+	mslot->tuple = &mslot->minhdr;
+}
+
+static void
+tts_minimal_release(TupleTableSlot *slot)
+{
+}
+
+static void
+tts_minimal_clear(TupleTableSlot *slot)
+{
+	MinimalTupleTableSlot *mslot = (MinimalTupleTableSlot *) slot;
+
+	/* FIXME */
+	if (slot->flags & TTS_SHOULDFREE)
+	{
+		heap_free_minimal_tuple(mslot->mintuple);
+		slot->flags &= ~TTS_SHOULDFREE;
+	}
+
+	slot->nvalid = 0;
+	slot->flags |= TTS_ISEMPTY;
+	mslot->off = 0;
+	mslot->mintuple = NULL;
+}
+
+static void
+tts_minimal_getsomeattrs(TupleTableSlot *slot, int natts)
+{
+	MinimalTupleTableSlot *mslot = (MinimalTupleTableSlot *) slot;
+
+	Assert(!(slot->flags & TTS_ISEMPTY));
+
+	slot_deform_tuple(slot, mslot->tuple, &mslot->off, natts);
+}
+
+static void
+tts_minimal_materialize(TupleTableSlot *slot)
+{
+	elog(ERROR, "materializing a minimal tuple");
+}
+
+static void
+tts_minimal_localize(TupleTableSlot *slot)
+{
+	MinimalTupleTableSlot *mslot = (MinimalTupleTableSlot *) slot;
+	MemoryContext oldContext;
+
+	Assert(!(slot->flags & TTS_ISEMPTY));
+
+	if (slot->flags & TTS_SHOULDFREE)
+		return;
+
+	slot->flags |= TTS_SHOULDFREE;
+	oldContext = MemoryContextSwitchTo(slot->mcxt);
+
+	if (!mslot->mintuple)
+		mslot->mintuple = heap_form_minimal_tuple(slot->tupleDescriptor,
+												  slot->values,
+												  slot->nulls);
+	else
+		mslot->mintuple = heap_copy_minimal_tuple(mslot->mintuple);
+	mslot->tuple = &mslot->minhdr;
+	mslot->minhdr.t_len = mslot->mintuple->t_len + MINIMAL_TUPLE_OFFSET;
+	mslot->minhdr.t_data = (HeapTupleHeader) ((char *) mslot->mintuple - MINIMAL_TUPLE_OFFSET);
+
+	MemoryContextSwitchTo(oldContext);
+
+	slot->nvalid = 0;
+	mslot->off = 0;
+}
+
+static HeapTuple
+tts_minimal_get_heap_tuple(TupleTableSlot *slot)
+{
+	MinimalTupleTableSlot *mslot = (MinimalTupleTableSlot *) slot;
+
+	Assert(!(slot->flags & TTS_ISEMPTY));
+	if (!mslot->mintuple)
+		tts_minimal_localize(slot);
+
+	return mslot->tuple;
+}
+
+static MinimalTuple
+tts_minimal_get_minimal_tuple(TupleTableSlot *slot)
+{
+	MinimalTupleTableSlot *mslot = (MinimalTupleTableSlot *) slot;
+
+	Assert(!(slot->flags & TTS_ISEMPTY));
+	if (!mslot->mintuple)
+		tts_minimal_localize(slot);
+
+	return mslot->mintuple;
+}
+
+static HeapTuple
+tts_minimal_copy_heap_tuple(TupleTableSlot *slot)
+{
+	MinimalTupleTableSlot *mslot = (MinimalTupleTableSlot *) slot;
+
+	if (!mslot->mintuple)
+		tts_minimal_localize(slot);
+
+	return heap_tuple_from_minimal_tuple(mslot->mintuple);
+}
+
+static MinimalTuple
+tts_minimal_copy_minimal_tuple(TupleTableSlot *slot)
+{
+	MinimalTupleTableSlot *mslot = (MinimalTupleTableSlot *) slot;
+
+	if (!mslot->mintuple)
+		tts_minimal_localize(slot);
+
+	return heap_copy_minimal_tuple(mslot->mintuple);
+}
+
+static void
+tts_minimal_store_tuple(TupleTableSlot *slot, MinimalTuple mtup, bool shouldFree)
+{
+	MinimalTupleTableSlot *mslot = (MinimalTupleTableSlot *) slot;
+
+	tts_minimal_clear(slot);
+
+	slot->flags &= ~TTS_ISEMPTY;
+	slot->nvalid = 0;
+	mslot->off = 0;
+
+	mslot->mintuple = mtup;
+	mslot->tuple = &mslot->minhdr;
+	mslot->minhdr.t_len = mtup->t_len + MINIMAL_TUPLE_OFFSET;
+	mslot->minhdr.t_data = (HeapTupleHeader) ((char *) mtup - MINIMAL_TUPLE_OFFSET);
+	/* no need to set t_self or t_tableOid since we won't allow access */
+
+	if (shouldFree)
+		slot->flags |= TTS_SHOULDFREE;
+	else
+		Assert(!(slot->flags & TTS_SHOULDFREE));
+}
+
+
+static void
+tts_buffer_init(TupleTableSlot *slot)
+{
+}
+
+static void
+tts_buffer_release(TupleTableSlot *slot)
+{
+}
+
+static void
+tts_buffer_clear(TupleTableSlot *slot)
+{
+	BufferHeapTupleTableSlot *bslot = (BufferHeapTupleTableSlot *) slot;
+
+	if (slot->flags & TTS_SHOULDFREE)
+	{
+		heap_freetuple(bslot->base.tuple);
+		slot->flags &= ~TTS_SHOULDFREE;
+	}
+
+	if (BufferIsValid(bslot->buffer))
+		ReleaseBuffer(bslot->buffer);
+
+	slot->nvalid = 0;
+	slot->flags |= TTS_ISEMPTY;
+	bslot->base.tuple = NULL;
+	bslot->buffer = InvalidBuffer;
+
+}
+
+static void
+tts_buffer_getsomeattrs(TupleTableSlot *slot, int natts)
+{
+	BufferHeapTupleTableSlot *bslot = (BufferHeapTupleTableSlot *) slot;
+
+	Assert(!(slot->flags & TTS_ISEMPTY));
+
+	slot_deform_tuple(slot, bslot->base.tuple, &bslot->base.off, natts);
+}
+
+static void
+tts_buffer_materialize(TupleTableSlot *slot)
+{
+	BufferHeapTupleTableSlot *bslot = (BufferHeapTupleTableSlot *) slot;
+	MemoryContext oldContext;
+
+	Assert(!(slot->flags & TTS_ISEMPTY));
+
+	if (slot->flags & TTS_SHOULDFREE)
+		return;
+
+	slot->flags |= TTS_SHOULDFREE;
+	oldContext = MemoryContextSwitchTo(slot->mcxt);
+
+	if (!bslot->base.tuple)
+		bslot->base.tuple = heap_form_tuple(slot->tupleDescriptor,
+											slot->values,
+											slot->nulls);
+	else
+		bslot->base.tuple = heap_copytuple(bslot->base.tuple);
+	MemoryContextSwitchTo(oldContext);
+
+
+	if (BufferIsValid(bslot->buffer))
+	{
+		ReleaseBuffer(bslot->buffer);
+		bslot->buffer = InvalidBuffer;
+	}
+
+	bslot->base.off = 0;
+	slot->nvalid = 0;
+
+}
+
+static HeapTuple
+tts_buffer_get_heap_tuple(TupleTableSlot *slot)
+{
+	BufferHeapTupleTableSlot *bslot = (BufferHeapTupleTableSlot *) slot;
+
+	Assert(!(slot->flags & TTS_ISEMPTY));
+	if (!bslot->base.tuple)
+		tts_buffer_materialize(slot);
+
+	return bslot->base.tuple;
+}
+
+static MinimalTuple
+tts_buffer_get_minimal_tuple(TupleTableSlot *slot)
+{
+	BufferHeapTupleTableSlot *bslot = (BufferHeapTupleTableSlot *) slot;
+
+	Assert(!(slot->flags & TTS_ISEMPTY));
+	if (!bslot->base.tuple)
+		tts_buffer_materialize(slot);
+
+	return minimal_tuple_from_heap_tuple(bslot->base.tuple);
+}
+
+static HeapTuple
+tts_buffer_copy_heap_tuple(TupleTableSlot *slot)
+{
+	BufferHeapTupleTableSlot *bslot = (BufferHeapTupleTableSlot *) slot;
+
+	Assert(!(slot->flags & TTS_ISEMPTY));
+	if (!bslot->base.tuple)
+		tts_buffer_materialize(slot);
+
+	return heap_copytuple(bslot->base.tuple);
+}
+
+static MinimalTuple
+tts_buffer_copy_minimal_tuple(TupleTableSlot *slot)
+{
+	BufferHeapTupleTableSlot *bslot = (BufferHeapTupleTableSlot *) slot;
+
+	if (!bslot->base.tuple)
+		tts_buffer_materialize(slot);
+
+	return minimal_tuple_from_heap_tuple(bslot->base.tuple);
+}
+
+static void
+tts_buffer_store_tuple(TupleTableSlot *slot, HeapTuple tuple, Buffer buffer)
+{
+	BufferHeapTupleTableSlot *bslot = (BufferHeapTupleTableSlot *) slot;
+
+	if (slot->flags & TTS_SHOULDFREE)
+	{
+		heap_freetuple(bslot->base.tuple);
+		slot->flags &= ~TTS_SHOULDFREE;
+	}
+
+	slot->flags &= ~TTS_ISEMPTY;
+	slot->nvalid = 0;
+	bslot->base.tuple = tuple;
+	bslot->base.off = 0;
+
+	/*
+	 * If tuple is on a disk page, keep the page pinned as long as we hold a
+	 * pointer into it.  We assume the caller already has such a pin.
+	 *
+	 * This is coded to optimize the case where the slot previously held a
+	 * tuple on the same disk page: in that case releasing and re-acquiring
+	 * the pin is a waste of cycles.  This is a common situation during
+	 * seqscans, so it's worth troubling over.
+	 */
+	if (bslot->buffer != buffer)
+	{
+		if (BufferIsValid(bslot->buffer))
+			ReleaseBuffer(bslot->buffer);
+		bslot->buffer = buffer;
+		IncrBufferRefCount(buffer);
+	}
+
+}
+
+
+static const TupleTableSlotOps TTSOpsVirtual = {
+	tts_virtual_init,
+	tts_virtual_release,
+	tts_virtual_clear,
+	tts_virtual_getsomeattrs,
+	tts_virtual_materialize,
+	tts_virtual_get_heap_tuple,
+	tts_virtual_get_minimal_tuple,
+	tts_virtual_copy_heap_tuple,
+	tts_virtual_copy_minimal_tuple,
+};
+
+static const TupleTableSlotOps TTSOpsHeapTuple = {
+	tts_heap_init,
+	tts_heap_release,
+	tts_heap_clear,
+	tts_heap_getsomeattrs,
+	tts_heap_materialize,
+	tts_heap_get_heap_tuple,
+	tts_heap_get_minimal_tuple,
+	tts_heap_copy_heap_tuple,
+	tts_heap_copy_minimal_tuple,
+};
+
+static const TupleTableSlotOps TTSOpsMinimalTuple = {
+	tts_minimal_init,
+	tts_minimal_release,
+	tts_minimal_clear,
+	tts_minimal_getsomeattrs,
+	tts_minimal_materialize,
+	tts_minimal_get_heap_tuple,
+	tts_minimal_get_minimal_tuple,
+	tts_minimal_copy_heap_tuple,
+	tts_minimal_copy_minimal_tuple,
+};
+
+static const TupleTableSlotOps TTSOpsBufferTuple = {
+	tts_buffer_init,
+	tts_buffer_release,
+	tts_buffer_clear,
+	tts_buffer_getsomeattrs,
+	tts_buffer_materialize,
+	tts_buffer_get_heap_tuple,
+	tts_buffer_get_minimal_tuple,
+	tts_buffer_copy_heap_tuple,
+	tts_buffer_copy_minimal_tuple,
+};
+
+
 /* --------------------------------
  *		MakeTupleTableSlot
  *
@@ -110,50 +664,75 @@ static TupleDesc ExecTypeFromTLInternal(List *targetList,
  * --------------------------------
  */
 TupleTableSlot *
-MakeTupleTableSlot(TupleDesc tupleDesc)
+MakeTupleTableSlot(TupleDesc tupleDesc, TupleTableSlotType st)
 {
-	Size		sz;
+	Size		basesz, allocsz;
 	TupleTableSlot *slot;
+	const TupleTableSlotOps *ops;
+
+	switch (st)
+	{
+		case TTS_TYPE_VIRTUAL:
+			ops = &TTSOpsVirtual;
+			basesz = sizeof(TupleTableSlot);
+			break;
+		case TTS_TYPE_HEAPTUPLE:
+			ops = &TTSOpsHeapTuple;
+			basesz = sizeof(HeapTupleTableSlot);
+			break;
+		case TTS_TYPE_MINIMALTUPLE:
+			ops = &TTSOpsMinimalTuple;
+			basesz = sizeof(MinimalTupleTableSlot);
+			break;
+		case TTS_TYPE_BUFFER:
+			ops = &TTSOpsBufferTuple;
+			basesz = sizeof(BufferHeapTupleTableSlot);
+			break;
+	}
+
+	/*
+	 * XXX: Main body of this should be in separate initialization
+	 * function so external types of slots can reuse.
+	 */
 
 	/*
 	 * When a fixed descriptor is specified, we can reduce overhead by
 	 * allocating the entire slot in one go.
 	 */
 	if (tupleDesc)
-		sz = MAXALIGN(sizeof(TupleTableSlot)) +
+		allocsz = MAXALIGN(basesz) +
 			MAXALIGN(tupleDesc->natts * sizeof(Datum)) +
 			MAXALIGN(tupleDesc->natts * sizeof(bool));
 	else
-		sz = sizeof(TupleTableSlot);
+		allocsz = basesz;
 
-	slot = palloc0(sz);
+	slot = palloc0(allocsz);
+	*((const TupleTableSlotOps **) &slot->cb) = ops;
 	slot->type = T_TupleTableSlot;
-	slot->tts_isempty = true;
-	slot->tts_shouldFree = false;
-	slot->tts_shouldFreeMin = false;
-	slot->tts_tuple = NULL;
-	slot->tts_fixedTupleDescriptor = tupleDesc != NULL;
-	slot->tts_tupleDescriptor = tupleDesc;
-	slot->tts_mcxt = CurrentMemoryContext;
-	slot->tts_buffer = InvalidBuffer;
-	slot->tts_nvalid = 0;
-	slot->tts_values = NULL;
-	slot->tts_isnull = NULL;
-	slot->tts_mintuple = NULL;
+	slot->flags = TTS_ISEMPTY;
+	slot->flags |= tupleDesc != NULL ? TTS_FIXED : 0;
+	slot->tupleDescriptor = tupleDesc;
+	slot->mcxt = CurrentMemoryContext;
+	slot->nvalid = 0;
 
 	if (tupleDesc != NULL)
 	{
-		slot->tts_values = (Datum *)
+		slot->values = (Datum *)
 			(((char *) slot)
-			 + MAXALIGN(sizeof(TupleTableSlot)));
-		slot->tts_isnull = (bool *)
+			 + MAXALIGN(basesz));
+		slot->nulls = (bool *)
 			(((char *) slot)
-			 + MAXALIGN(sizeof(TupleTableSlot))
+			 + MAXALIGN(basesz)
 			 + MAXALIGN(tupleDesc->natts * sizeof(Datum)));
 
 		PinTupleDesc(tupleDesc);
 	}
 
+	/*
+	 * And allow slot type specific initialization.
+	 */
+	slot->cb->init(slot);
+
 	return slot;
 }
 
@@ -164,9 +743,9 @@ MakeTupleTableSlot(TupleDesc tupleDesc)
  * --------------------------------
  */
 TupleTableSlot *
-ExecAllocTableSlot(List **tupleTable, TupleDesc desc)
+ExecAllocTableSlot(List **tupleTable, TupleDesc desc, TupleTableSlotType st)
 {
-	TupleTableSlot *slot = MakeTupleTableSlot(desc);
+	TupleTableSlot *slot = MakeTupleTableSlot(desc, st);
 
 	*tupleTable = lappend(*tupleTable, slot);
 
@@ -194,21 +773,21 @@ ExecResetTupleTable(List *tupleTable,	/* tuple table */
 
 		/* Always release resources and reset the slot to empty */
 		ExecClearTuple(slot);
-		if (slot->tts_tupleDescriptor)
+		if (slot->tupleDescriptor)
 		{
-			ReleaseTupleDesc(slot->tts_tupleDescriptor);
-			slot->tts_tupleDescriptor = NULL;
+			ReleaseTupleDesc(slot->tupleDescriptor);
+			slot->tupleDescriptor = NULL;
 		}
 
 		/* If shouldFree, release memory occupied by the slot itself */
 		if (shouldFree)
 		{
-			if (!slot->tts_fixedTupleDescriptor)
+			if (!(slot->flags & TTS_FIXED))
 			{
-				if (slot->tts_values)
-					pfree(slot->tts_values);
-				if (slot->tts_isnull)
-					pfree(slot->tts_isnull);
+				if (slot->values)
+					pfree(slot->values);
+				if (slot->nulls)
+					pfree(slot->nulls);
 			}
 			pfree(slot);
 		}
@@ -229,9 +808,9 @@ ExecResetTupleTable(List *tupleTable,	/* tuple table */
  * --------------------------------
  */
 TupleTableSlot *
-MakeSingleTupleTableSlot(TupleDesc tupdesc)
+MakeSingleTupleTableSlot(TupleDesc tupdesc, TupleTableSlotType st)
 {
-	TupleTableSlot *slot = MakeTupleTableSlot(tupdesc);
+	TupleTableSlot *slot = MakeTupleTableSlot(tupdesc, st);
 
 	return slot;
 }
@@ -246,17 +825,18 @@ MakeSingleTupleTableSlot(TupleDesc tupdesc)
 void
 ExecDropSingleTupleTableSlot(TupleTableSlot *slot)
 {
+	slot->cb->release(slot);
 	/* This should match ExecResetTupleTable's processing of one slot */
 	Assert(IsA(slot, TupleTableSlot));
 	ExecClearTuple(slot);
-	if (slot->tts_tupleDescriptor)
-		ReleaseTupleDesc(slot->tts_tupleDescriptor);
-	if (!slot->tts_fixedTupleDescriptor)
+	if (slot->tupleDescriptor)
+		ReleaseTupleDesc(slot->tupleDescriptor);
+	if (!(slot->flags & TTS_FIXED))
 	{
-		if (slot->tts_values)
-			pfree(slot->tts_values);
-		if (slot->tts_isnull)
-			pfree(slot->tts_isnull);
+		if (slot->values)
+			pfree(slot->values);
+		if (slot->nulls)
+			pfree(slot->nulls);
 	}
 	pfree(slot);
 }
@@ -281,7 +861,7 @@ void
 ExecSetSlotDescriptor(TupleTableSlot *slot, /* slot to change */
 					  TupleDesc tupdesc)	/* new tuple descriptor */
 {
-	Assert(!slot->tts_fixedTupleDescriptor);
+	Assert(!(slot->flags & TTS_FIXED));
 
 	/* For safety, make sure slot is empty before changing it */
 	ExecClearTuple(slot);
@@ -290,28 +870,28 @@ ExecSetSlotDescriptor(TupleTableSlot *slot, /* slot to change */
 	 * Release any old descriptor.  Also release old Datum/isnull arrays if
 	 * present (we don't bother to check if they could be re-used).
 	 */
-	if (slot->tts_tupleDescriptor)
-		ReleaseTupleDesc(slot->tts_tupleDescriptor);
+	if (slot->tupleDescriptor)
+		ReleaseTupleDesc(slot->tupleDescriptor);
 
-	if (slot->tts_values)
-		pfree(slot->tts_values);
-	if (slot->tts_isnull)
-		pfree(slot->tts_isnull);
+	if (slot->values)
+		pfree(slot->values);
+	if (slot->nulls)
+		pfree(slot->nulls);
 
 	/*
 	 * Install the new descriptor; if it's refcounted, bump its refcount.
 	 */
-	slot->tts_tupleDescriptor = tupdesc;
+	slot->tupleDescriptor = tupdesc;
 	PinTupleDesc(tupdesc);
 
 	/*
 	 * Allocate Datum/isnull arrays of the appropriate size.  These must have
 	 * the same lifetime as the slot, so allocate in the slot's own context.
 	 */
-	slot->tts_values = (Datum *)
-		MemoryContextAlloc(slot->tts_mcxt, tupdesc->natts * sizeof(Datum));
-	slot->tts_isnull = (bool *)
-		MemoryContextAlloc(slot->tts_mcxt, tupdesc->natts * sizeof(bool));
+	slot->values = (Datum *)
+		MemoryContextAlloc(slot->mcxt, tupdesc->natts * sizeof(Datum));
+	slot->nulls = (bool *)
+		MemoryContextAlloc(slot->mcxt, tupdesc->natts * sizeof(bool));
 }
 
 /* --------------------------------
@@ -363,51 +943,28 @@ ExecStoreTuple(HeapTuple tuple,
 	 */
 	Assert(tuple != NULL);
 	Assert(slot != NULL);
-	Assert(slot->tts_tupleDescriptor != NULL);
+	Assert(slot->tupleDescriptor != NULL);
 	/* passing shouldFree=true for a tuple on a disk page is not sane */
 	Assert(BufferIsValid(buffer) ? (!shouldFree) : true);
 
-	/*
-	 * Free any old physical tuple belonging to the slot.
-	 */
-	if (slot->tts_shouldFree)
-		heap_freetuple(slot->tts_tuple);
-	if (slot->tts_shouldFreeMin)
-		heap_free_minimal_tuple(slot->tts_mintuple);
-
-	/*
-	 * Store the new tuple into the specified slot.
-	 */
-	slot->tts_isempty = false;
-	slot->tts_shouldFree = shouldFree;
-	slot->tts_shouldFreeMin = false;
-	slot->tts_tuple = tuple;
-	slot->tts_mintuple = NULL;
-
-	/* Mark extracted state invalid */
-	slot->tts_nvalid = 0;
-
-	/*
-	 * If tuple is on a disk page, keep the page pinned as long as we hold a
-	 * pointer into it.  We assume the caller already has such a pin.
-	 *
-	 * This is coded to optimize the case where the slot previously held a
-	 * tuple on the same disk page: in that case releasing and re-acquiring
-	 * the pin is a waste of cycles.  This is a common situation during
-	 * seqscans, so it's worth troubling over.
-	 */
-	if (slot->tts_buffer != buffer)
+	if (BufferIsValid(buffer))
 	{
-		if (BufferIsValid(slot->tts_buffer))
-			ReleaseBuffer(slot->tts_buffer);
-		slot->tts_buffer = buffer;
-		if (BufferIsValid(buffer))
-			IncrBufferRefCount(buffer);
+		if (slot->cb != &TTSOpsBufferTuple)
+			elog(ERROR, "trying to store buffer tuple into wrong type of slot");
+		tts_buffer_store_tuple(slot, tuple, buffer);
+	}
+	else
+	{
+		if (slot->cb != &TTSOpsHeapTuple)
+			elog(ERROR, "trying to store heap tuple into wrong type of slot");
+		tts_heap_store_tuple(slot, tuple, shouldFree);
+
 	}
 
 	return slot;
 }
 
+
 /* --------------------------------
  *		ExecStoreMinimalTuple
  *
@@ -426,88 +983,15 @@ ExecStoreMinimalTuple(MinimalTuple mtup,
 	 */
 	Assert(mtup != NULL);
 	Assert(slot != NULL);
-	Assert(slot->tts_tupleDescriptor != NULL);
+	Assert(slot->tupleDescriptor != NULL);
 
-	/*
-	 * Free any old physical tuple belonging to the slot.
-	 */
-	if (slot->tts_shouldFree)
-		heap_freetuple(slot->tts_tuple);
-	if (slot->tts_shouldFreeMin)
-		heap_free_minimal_tuple(slot->tts_mintuple);
-
-	/*
-	 * Drop the pin on the referenced buffer, if there is one.
-	 */
-	if (BufferIsValid(slot->tts_buffer))
-		ReleaseBuffer(slot->tts_buffer);
-
-	slot->tts_buffer = InvalidBuffer;
-
-	/*
-	 * Store the new tuple into the specified slot.
-	 */
-	slot->tts_isempty = false;
-	slot->tts_shouldFree = false;
-	slot->tts_shouldFreeMin = shouldFree;
-	slot->tts_tuple = &slot->tts_minhdr;
-	slot->tts_mintuple = mtup;
-
-	slot->tts_minhdr.t_len = mtup->t_len + MINIMAL_TUPLE_OFFSET;
-	slot->tts_minhdr.t_data = (HeapTupleHeader) ((char *) mtup - MINIMAL_TUPLE_OFFSET);
-	/* no need to set t_self or t_tableOid since we won't allow access */
-
-	/* Mark extracted state invalid */
-	slot->tts_nvalid = 0;
+	if (slot->cb != &TTSOpsMinimalTuple)
+		elog(ERROR, "trying to store minimal tuple into wrong type of slot");
+	tts_minimal_store_tuple(slot, mtup, shouldFree);
 
 	return slot;
 }
 
-/* --------------------------------
- *		ExecClearTuple
- *
- *		This function is used to clear out a slot in the tuple table.
- *
- *		NB: only the tuple is cleared, not the tuple descriptor (if any).
- * --------------------------------
- */
-TupleTableSlot *				/* return: slot passed */
-ExecClearTuple(TupleTableSlot *slot)	/* slot in which to store tuple */
-{
-	/*
-	 * sanity checks
-	 */
-	Assert(slot != NULL);
-
-	/*
-	 * Free the old physical tuple if necessary.
-	 */
-	if (slot->tts_shouldFree)
-		heap_freetuple(slot->tts_tuple);
-	if (slot->tts_shouldFreeMin)
-		heap_free_minimal_tuple(slot->tts_mintuple);
-
-	slot->tts_tuple = NULL;
-	slot->tts_mintuple = NULL;
-	slot->tts_shouldFree = false;
-	slot->tts_shouldFreeMin = false;
-
-	/*
-	 * Drop the pin on the referenced buffer, if there is one.
-	 */
-	if (BufferIsValid(slot->tts_buffer))
-		ReleaseBuffer(slot->tts_buffer);
-
-	slot->tts_buffer = InvalidBuffer;
-
-	/*
-	 * Mark it empty.
-	 */
-	slot->tts_isempty = true;
-	slot->tts_nvalid = 0;
-
-	return slot;
-}
 
 /* --------------------------------
  *		ExecStoreVirtualTuple
@@ -527,11 +1011,11 @@ ExecStoreVirtualTuple(TupleTableSlot *slot)
 	 * sanity checks
 	 */
 	Assert(slot != NULL);
-	Assert(slot->tts_tupleDescriptor != NULL);
-	Assert(slot->tts_isempty);
+	Assert(slot->tupleDescriptor != NULL);
+	Assert(slot->flags & TTS_ISEMPTY);
 
-	slot->tts_isempty = false;
-	slot->tts_nvalid = slot->tts_tupleDescriptor->natts;
+	slot->flags &= ~TTS_ISEMPTY;
+	slot->nvalid = slot->tupleDescriptor->natts;
 
 	return slot;
 }
@@ -551,7 +1035,7 @@ ExecStoreAllNullTuple(TupleTableSlot *slot)
 	 * sanity checks
 	 */
 	Assert(slot != NULL);
-	Assert(slot->tts_tupleDescriptor != NULL);
+	Assert(slot->tupleDescriptor != NULL);
 
 	/* Clear any old contents */
 	ExecClearTuple(slot);
@@ -559,82 +1043,14 @@ ExecStoreAllNullTuple(TupleTableSlot *slot)
 	/*
 	 * Fill all the columns of the virtual tuple with nulls
 	 */
-	MemSet(slot->tts_values, 0,
-		   slot->tts_tupleDescriptor->natts * sizeof(Datum));
-	memset(slot->tts_isnull, true,
-		   slot->tts_tupleDescriptor->natts * sizeof(bool));
+	MemSet(slot->values, 0,
+		   slot->tupleDescriptor->natts * sizeof(Datum));
+	memset(slot->nulls, true,
+		   slot->tupleDescriptor->natts * sizeof(bool));
 
 	return ExecStoreVirtualTuple(slot);
 }
 
-/* --------------------------------
- *		ExecCopySlotTuple
- *			Obtain a copy of a slot's regular physical tuple.  The copy is
- *			palloc'd in the current memory context.
- *			The slot itself is undisturbed.
- *
- *		This works even if the slot contains a virtual or minimal tuple;
- *		however the "system columns" of the result will not be meaningful.
- * --------------------------------
- */
-HeapTuple
-ExecCopySlotTuple(TupleTableSlot *slot)
-{
-	/*
-	 * sanity checks
-	 */
-	Assert(slot != NULL);
-	Assert(!slot->tts_isempty);
-
-	/*
-	 * If we have a physical tuple (either format) then just copy it.
-	 */
-	if (TTS_HAS_PHYSICAL_TUPLE(slot))
-		return heap_copytuple(slot->tts_tuple);
-	if (slot->tts_mintuple)
-		return heap_tuple_from_minimal_tuple(slot->tts_mintuple);
-
-	/*
-	 * Otherwise we need to build a tuple from the Datum array.
-	 */
-	return heap_form_tuple(slot->tts_tupleDescriptor,
-						   slot->tts_values,
-						   slot->tts_isnull);
-}
-
-/* --------------------------------
- *		ExecCopySlotMinimalTuple
- *			Obtain a copy of a slot's minimal physical tuple.  The copy is
- *			palloc'd in the current memory context.
- *			The slot itself is undisturbed.
- * --------------------------------
- */
-MinimalTuple
-ExecCopySlotMinimalTuple(TupleTableSlot *slot)
-{
-	/*
-	 * sanity checks
-	 */
-	Assert(slot != NULL);
-	Assert(!slot->tts_isempty);
-
-	/*
-	 * If we have a physical tuple then just copy it.  Prefer to copy
-	 * tts_mintuple since that's a tad cheaper.
-	 */
-	if (slot->tts_mintuple)
-		return heap_copy_minimal_tuple(slot->tts_mintuple);
-	if (slot->tts_tuple)
-		return minimal_tuple_from_heap_tuple(slot->tts_tuple);
-
-	/*
-	 * Otherwise we need to build a tuple from the Datum array.
-	 */
-	return heap_form_minimal_tuple(slot->tts_tupleDescriptor,
-								   slot->tts_values,
-								   slot->tts_isnull);
-}
-
 /* --------------------------------
  *		ExecFetchSlotTuple
  *			Fetch the slot's regular physical tuple.
@@ -657,18 +1073,9 @@ ExecFetchSlotTuple(TupleTableSlot *slot)
 	 * sanity checks
 	 */
 	Assert(slot != NULL);
-	Assert(!slot->tts_isempty);
+	Assert(!(slot->flags & TTS_ISEMPTY));
 
-	/*
-	 * If we have a regular physical tuple then just return it.
-	 */
-	if (TTS_HAS_PHYSICAL_TUPLE(slot))
-		return slot->tts_tuple;
-
-	/*
-	 * Otherwise materialize the slot...
-	 */
-	return ExecMaterializeSlot(slot);
+	return slot->cb->get_heap_tuple(slot);
 }
 
 /* --------------------------------
@@ -687,14 +1094,23 @@ ExecFetchSlotTuple(TupleTableSlot *slot)
 MinimalTuple
 ExecFetchSlotMinimalTuple(TupleTableSlot *slot)
 {
+#ifdef NOT_ANYMORE
 	MemoryContext oldContext;
+#endif
 
 	/*
 	 * sanity checks
 	 */
 	Assert(slot != NULL);
-	Assert(!slot->tts_isempty);
+	Assert(!(slot->flags & TTS_ISEMPTY));
 
+	if (slot->cb == &TTSOpsMinimalTuple)
+		return tts_minimal_get_minimal_tuple(slot);
+	else
+		/* XXX: this'll copy! */
+		return slot->cb->get_minimal_tuple(slot);
+
+#ifdef NOT_ANYMORE
 	/*
 	 * If we have a minimal physical tuple (local or not) then just return it.
 	 */
@@ -721,6 +1137,7 @@ ExecFetchSlotMinimalTuple(TupleTableSlot *slot)
 	 */
 
 	return slot->tts_mintuple;
+#endif
 }
 
 /* --------------------------------
@@ -738,85 +1155,12 @@ ExecFetchSlotTupleDatum(TupleTableSlot *slot)
 
 	/* Fetch slot's contents in regular-physical-tuple form */
 	tup = ExecFetchSlotTuple(slot);
-	tupdesc = slot->tts_tupleDescriptor;
+	tupdesc = slot->tupleDescriptor;
 
 	/* Convert to Datum form */
 	return heap_copy_tuple_as_datum(tup, tupdesc);
 }
 
-/* --------------------------------
- *		ExecMaterializeSlot
- *			Force a slot into the "materialized" state.
- *
- *		This causes the slot's tuple to be a local copy not dependent on
- *		any external storage.  A pointer to the contained tuple is returned.
- *
- *		A typical use for this operation is to prepare a computed tuple
- *		for being stored on disk.  The original data may or may not be
- *		virtual, but in any case we need a private copy for heap_insert
- *		to scribble on.
- * --------------------------------
- */
-HeapTuple
-ExecMaterializeSlot(TupleTableSlot *slot)
-{
-	MemoryContext oldContext;
-
-	/*
-	 * sanity checks
-	 */
-	Assert(slot != NULL);
-	Assert(!slot->tts_isempty);
-
-	/*
-	 * If we have a regular physical tuple, and it's locally palloc'd, we have
-	 * nothing to do.
-	 */
-	if (slot->tts_tuple && slot->tts_shouldFree)
-		return slot->tts_tuple;
-
-	/*
-	 * Otherwise, copy or build a physical tuple, and store it into the slot.
-	 *
-	 * We may be called in a context that is shorter-lived than the tuple
-	 * slot, but we have to ensure that the materialized tuple will survive
-	 * anyway.
-	 */
-	oldContext = MemoryContextSwitchTo(slot->tts_mcxt);
-	slot->tts_tuple = ExecCopySlotTuple(slot);
-	slot->tts_shouldFree = true;
-	MemoryContextSwitchTo(oldContext);
-
-	/*
-	 * Drop the pin on the referenced buffer, if there is one.
-	 */
-	if (BufferIsValid(slot->tts_buffer))
-		ReleaseBuffer(slot->tts_buffer);
-
-	slot->tts_buffer = InvalidBuffer;
-
-	/*
-	 * Mark extracted state invalid.  This is important because the slot is
-	 * not supposed to depend any more on the previous external data; we
-	 * mustn't leave any dangling pass-by-reference datums in tts_values.
-	 * However, we have not actually invalidated any such datums, if there
-	 * happen to be any previously fetched from the slot.  (Note in particular
-	 * that we have not pfree'd tts_mintuple, if there is one.)
-	 */
-	slot->tts_nvalid = 0;
-
-	/*
-	 * On the same principle of not depending on previous remote storage,
-	 * forget the mintuple if it's not local storage.  (If it is local
-	 * storage, we must not pfree it now, since callers might have already
-	 * fetched datum pointers referencing it.)
-	 */
-	if (!slot->tts_shouldFreeMin)
-		slot->tts_mintuple = NULL;
-
-	return slot->tts_tuple;
-}
-
 /* --------------------------------
  *		ExecCopySlot
  *			Copy the source slot's contents into the destination slot.
@@ -830,19 +1174,16 @@ ExecMaterializeSlot(TupleTableSlot *slot)
 TupleTableSlot *
 ExecCopySlot(TupleTableSlot *dstslot, TupleTableSlot *srcslot)
 {
-	HeapTuple	newTuple;
-	MemoryContext oldContext;
+	int natts = srcslot->tupleDescriptor->natts;
 
-	/*
-	 * There might be ways to optimize this when the source is virtual, but
-	 * for now just always build a physical copy.  Make sure it is in the
-	 * right context.
-	 */
-	oldContext = MemoryContextSwitchTo(dstslot->tts_mcxt);
-	newTuple = ExecCopySlotTuple(srcslot);
-	MemoryContextSwitchTo(oldContext);
+	ExecClearTuple(dstslot);
+	/* XXX: optimize when tuple based? */
+	slot_getallattrs(srcslot);
+	memcpy(dstslot->values, srcslot->values, sizeof(Datum) * natts);
+	memcpy(dstslot->nulls, srcslot->nulls, sizeof(bool) * natts);
+	ExecStoreVirtualTuple(dstslot);
 
-	return ExecStoreTuple(newTuple, dstslot, InvalidBuffer, true);
+	return dstslot;
 }
 
 
